/*******************************************************
 ***
 ***      Arithmetic Interpreter        Version 2.2
 ***
 ***               Objective-C Version
 ***
 *******************************************************/

#ifndef __OCINTERPRETER__
#define __OCINTERPRETER__

#define SOLARIS   1
#define MACOSX    0
#define MACOS     0


#if MACOSX
#import <Foundation/Foundation.h>
#endif

#if SOLARIS
#include <objc/Object.h>
#endif

#if MACOS
#import "MWObjC.h"
#endif

char * CopyPartialString(char * inString,short inStart,short inEnd);
float CalcValue(char * inString,short inIndex);
void FindOperator(short * oper,short * esp,char * inString,short pos);

#if MACOSX
@interface OCNode: NSObject
#endif

#if SOLARIS
@interface OCNode: Object
#endif

#if MACOS
@interface OCNode: MWObject
#endif
{
short    operator_;
float    value_;
OCNode * fg_;
OCNode * fd_;
}
-(id) init;
-(id) initWithOperator:(short) Operator value:(float) value fg:(OCNode *) fg fd:(OCNode *) fd;

-(id) setFg:(OCNode *) fg;
-(id) setFd:(OCNode *) fd;

-(float) ComputeTreewithXValue:(float) xvalue YValue:(float) yvalue error:(short *) error;
-(void) WriteTree:(char *) inString;

@end

OCNode * ConstructTree(char * string,short length,short * error);

#endif
